/* keep in sync with mailnews/base/public/nsMsgFolderFlags.h */
//const MSG_FOLDER_FLAG_VIRTUAL = 0x0020;

var gsio_tree_view;
var gMyAddr=new Object;
var gHeaderParser = Components.classes["@mozilla.org/messenger/headerparser;1"].
        getService(Components.interfaces.nsIMsgHeaderParser);
var gPrefs = Components.classes["@mozilla.org/preferences-service;1"].
        getService(Components.interfaces.nsIPrefBranch);

var sioData = new Object;
var sioAddr = new Object;

var gPrefixType;
var gInTextPrefix='';
var gOutTextPrefix='';

function sio_init() {

  /*
   * Overlay sio_RerootThreadPane from mailnews\base\resources\content\threadPane.js@506
   *  Despite the fact, that there's a new custom column mechanism in TB 2.0
   *  we continue to overload the tree-view, since we want to continue to
   *  set properties on non-custom columns
   */
  var tree = GetThreadTree();
  // save original function
  var sio_RerootThreadPane=window.RerootThreadPane;
  // and replace with my version...
  window.RerootThreadPane=function() {
    // which first calls the original funtion
    var retval = sio_RerootThreadPane.apply(this, arguments);
    // create wrapper
    gsio_tree_view = new sio_msg_tree_view();
    // save original view
    gsio_tree_view.wrapped_view =
      tree.boxObject.QueryInterface(Components.interfaces.nsITreeBoxObject).view;
    // and replace with my version
    tree.boxObject.QueryInterface(Components.interfaces.nsITreeBoxObject).view=
      gsio_tree_view;
    return retval;
  }

  //see http://developer.mozilla.org/en/docs/Extensions:Thunderbird:Creating_a_Custom_Column
  // this is a noop (since "MsgCreateDBView" is not available),
  // if the custom column mechanism is not available (as in TB<2.0)
  var ObserverService = Components.classes["@mozilla.org/observer-service;1"].
    getService(Components.interfaces.nsIObserverService);
  ObserverService.addObserver(sio_CreateDbObserver, "MsgCreateDBView", false);

/***vvv V1 only vvv***/
  // if the <treecols id="threadCols"> only contains my additional columns,
  // i have to use the pre-TB2.0 mechanism to merge the new columns with the others
  var cols=document.getElementById('threadCols');
  if (cols.firstChild.nextSibling.id && cols.firstChild.nextSibling.id.substring(0,4)=='sio_') {
dump('OLD XUL VERSION\n');
    /*
     *  Move the elements from our additional treecols to the main treecols
     *  They have to be insertet in increasding order of ordinal!
     *  May produce incorrect results, if other extensions also inserts columns!
     */
//    var tree=document.getElementById('threadTree');
    var treecols=tree.firstChild;
    var newcols=treecols.nextSibling;
  //  if (newcols && newcols.id=='threadCols') { //TB 1.5
    var newcols=document.getElementById('threadCols');
//  dump('sio init\n');

  /*
   * Insert new cols into the tree
   */
    // get positions of normal elements
    var posNormal=new Array;
    var colNodes=treecols.childNodes;
    for (var i=0; i<colNodes.length; i++) {
      var col=colNodes[i];
      if (col.nodeName=="treecol") {
        posNormal[col.ordinal]=col;
  //dump(col.id+' '+col.ordinal+'\n');
      }
    }
    // get positions of my additional elements
    var posNew=new Array;
    var splitters=new Array;
    colNodes=newcols.childNodes;
    for (var i=0; i<colNodes.length; i++) {
      var col=colNodes[i];
      if (col.nodeName=="treecol") {
        col.tooltipText=null; //Not sortable
      	var pos=col.ordinal;
        if (pos<0) pos=7; //might happen after bad install
      	while (posNew[pos]) pos+=2; //must stay odd
        posNew[pos]=col;
  //dump(col.id+' '+pos+'\n');
      } else
        splitters.push(col);
    }

    //append new cols and move into the right position
    var offset=0;
    for (var i=0; i<posNew.length; i++) {
      var node;
      if (!(node=posNew[i])) continue;
      var splitter=splitters.shift();
      treecols.appendChild(splitter);
      treecols.appendChild(node);
      splitter.ordinal=100;
      node.ordinal=101;
      var insertHere=i<posNormal.length?posNormal[i-offset]:posNormal[posNormal.length-1];
  //dump('insert '+node.id+' before '+insertHere.id+'('+insertHere.ordinal+', '+(i<posNormal.length)+')'+'\n');
        //undocumented functions from toolkit\content\global\bindings\tree.xml
  //    tree._columnsDirty=true;
      tree._reorderColumn(node, insertHere, i<posNormal.length);
      offset+=2;
    }
    tree.removeChild(newcols);

    /*
    dump('---\n');
    var c=treecols.childNodes;
    for (var i=0; i<c.length; i++) {
      var col=c[i];
      if (col.nodeName=="treecol")
    dump(col.id+' '+col.ordinal+'\n');
    }
    */

  } // end of TB Version 1 move of columns
/***^^^ V1 only ^^^***/

/*
 *  Find all email addresses, which count as mine
 */
  var accountMgr=
    Components.classes["@mozilla.org/messenger/account-manager;1"].
      getService(Components.interfaces.nsIMsgAccountManager);
  var allAccounts=accountMgr.accounts;
  var accountsCount = allAccounts.Count();
  for (var i = 0; i < accountsCount; i++) {
    var account = allAccounts.QueryElementAt(i, Components.interfaces.nsIMsgAccount);
    var allIdentities=account.identities;
    var identitiesCount = allIdentities.Count();
    for (var j = 0; j < identitiesCount; j++) {
      var identity = allIdentities.QueryElementAt(j, Components.interfaces.nsIMsgIdentity);
      var email=identity.email.toLowerCase();
      if (gMyAddr[email]===undefined)
        gMyAddr[email]=1;
//dump(identity.email+'\n');
    }
  }

  try { gPrefixType = gPrefs.getCharPref("extensions.showInOut.PrefixType"); } catch(e) { gPrefixType='none'; }
  if (gPrefixType=='text') {
    try { gInTextPrefix = gPrefs.getCharPref("extensions.showInOut.InTextPrefix"); } catch(e) { gInTextPrefix=''; }
    try { gOutTextPrefix = gPrefs.getCharPref("extensions.showInOut.OutTextPrefix"); } catch(e) { gOutTextPrefix=''; }
  }

}

function sio_extractName(email, isJunk) {
  var addrs={};
  var names={};
  var full={};
  var count=0;
  count=gHeaderParser.parseHeadersWithArray( email, addrs, names, full, count);
  var show='';
  for (var i=0; i<count; i++) {
    if (isJunk)
      s=full.value[i];
    else {
      s=names.value[i];
      if (!s) s=addrs.value[i];
      if (s.indexOf(',')>=0) s='"'+s+'"';
    }
    if (show) show+=', ';
    show+=s;
  }
  return show;
}

function sio_getMsgInfo(row, messageURI, msgHdr) {
  if (!msgHdr) {
    var key=gDBView.getKeyAt(row);
    msgHdr = gDBView.db.GetMsgHdrForKey(key);
  }
  // extract just the mail address from the author and compare to the list of 'my' Addresses
  var author = gHeaderParser.extractHeaderAddressMailboxes(null, msgHdr.author).toLowerCase();
  var received=gMyAddr[author]===undefined?'in':'out';

  sioData[messageURI]=received;

  var junkScore = msgHdr.getStringProperty("junkscore");
  // according to SelectedMessagesAreJunk() in mailWindowOverlay.js:
  var isJunk =  ((junkScore != "") && (junkScore != "0"));
  // but i think its:
  //var isJunk =  ((junkScore === "") || (junkScore != "0"));
  sioAddr[messageURI] = received=='in' ?
      gInTextPrefix+sio_extractName(msgHdr.mime2DecodedAuthor, isJunk)  :
      gOutTextPrefix+sio_extractName(msgHdr.mime2DecodedRecipients, false) ;
}

/* for TB V2.0 */
var sio_columnHandler_inoutCol = {
  getCellText:         function(row, col) {
  },
  getCellProperties:   function(row, col, props) {
  },
  getImageSrc:         function(row, col) {
    return null;
  },
//  	colHandler->IsEditable(row, col, _retval);
//  	colHandler->CycleCell(row, col);

  getSortStringForRow: function(hdr) {
    return '';
  },
  getSortLongForRow:   function(hdr) {
    var messageURI=hdr.folder.getUriForMsg(hdr);
    if (sioData[messageURI] === undefined) {
      sio_getMsgInfo(null, messageURI, hdr);
    }
    if (sioData[messageURI]=='in') return 0;
    else return 1;
  },
  isString:            function() {
    return false;
  }

}
var sio_columnHandler_inoutaddressCol = {
  getCellText:         function(row, col) {
 },
  getCellProperties:   function(row, col, props) {
  },
  getImageSrc:         function(row, col) {
    return null;
  },
//  	colHandler->IsEditable(row, col, _retval);
//  	colHandler->CycleCell(row, col);

  getSortStringForRow: function(hdr) {
    var messageURI=hdr.folder.getUriForMsg(hdr);
    if (sioData[messageURI] === undefined) {
      sio_getMsgInfo(null, messageURI, hdr);
    }
    var s=sioAddr[messageURI];
    if (s.substr(0,1)=='"') s=s.substr(1);
    return s;
  },
  getSortLongForRow:   function(hdr) {
    return 0;
  },
  isString:            function() {
    return true;
  }

}


function sio_msg_tree_view() {}

sio_msg_tree_view.prototype = {

   // The wrapped nsITreeView (nsIMsgDBView) object.
  wrapped_view : null,

  getCellProperties : function( row , col , properties )   //called
  {
    this.wrapped_view.getCellProperties ( row , col , properties )
//set it for ALL columns
//    if(col.id == "sio_inoutCol") {
      var messageURI = gDBView.getURIForViewIndex(row);
      if (sioData[messageURI] === undefined) {
        sio_getMsgInfo(row, messageURI);
      }
      var received=sioData[messageURI];
        //properties already defined:
        //    focus, [leaf|container], [even|odd], sio_inoutCol
        //  appending [in|out]
      if (received!==null) {
        var aserv=Components.classes["@mozilla.org/atom-service;1"].
                  getService(Components.interfaces.nsIAtomService);
        properties.AppendElement(aserv.getAtom(received));
      }
//dumpProps(row, col, properties);
      return;
//    }
//    return this.wrapped_view.getCellProperties ( row , col , properties )
  },
  getCellText : function(row, col)
  {
//dump('sio: get cell for '+col.id+'\n');
    if (col.id == "sio_inoutCol")
      return '';
    else if (col.id == "sio_inoutaddressCol") {
      var messageURI = gDBView.getURIForViewIndex(row);
      if (sioData[messageURI] === undefined)
        sio_getMsgInfo(row, messageURI);
//should probably use: FetchAuthor(msgHdr);
//should probably use: FetchRecipients(msgHdr);
      return sioAddr[messageURI];
    }
    return this.wrapped_view.getCellText(row, col);
  },
  getImageSrc : function ( row , col )
  {
/*
    if (col.id == "sio_inoutaddressCol") {  //called!!
      // image inserted in front of the text, returned in getCellText
      return "chrome://showInOut/skin/out.png";
    }
*/
    return this.wrapped_view.getImageSrc ( row , col )
  },
  getRowProperties : function ( index , properties )
  {
//    dump('getRowProperties\n');
    this.wrapped_view.getRowProperties ( index , properties );
    var messageURI = gDBView.getURIForViewIndex(index);
    if (sioData[messageURI] === undefined) {
      sio_getMsgInfo(index, messageURI);
    }
    var received=sioData[messageURI];
      //properties already defined:
      //    ???
      //  appending [in|out]
    if (received!==null) {
      var aserv=Components.classes["@mozilla.org/atom-service;1"].
                getService(Components.interfaces.nsIAtomService);
      properties.AppendElement(aserv.getAtom(received));
    }
//dumpProps(index, -1, properties);
    return;
//    return this.wrapped_view.getRowProperties ( index , properties )
  },
  setTree : function ( tree ) //called
  { // seems to be called, when a new folder is selected
//    dump('sio: setTree '+tree+'\n');
    sioData=new Object;
    sioAddr=new Object;
    return this.wrapped_view.setTree ( tree );
  },


  ////////////////////////////////////////////////////

   // Redefine QueryInterface().
  QueryInterface : function(iid)
  {
    if(iid.equals(Components.interfaces.nsITreeView) || iid.equals(Components.interfaces.nsISupports))
          return this;

    throw Components.results.NS_NOINTERFACE;
  },

   // Wrapped constants

  DROP_BEFORE : Components.interfaces.nsITreeView.DROP_BEFORE,
 	DROP_ON : Components.interfaces.nsITreeView.DROP_ON,
 	DROP_AFTER : Components.interfaces.nsITreeView.DROP_AFTER,
 	PROGRESS_NORMAL : Components.interfaces.nsITreeView.PROGRESS_NORMAL,
 	PROGRESS_UNDETERMINED : Components.interfaces.nsITreeView.PROGRESS_UNDETERMINED,
 	PROGRESS_NONE : Components.interfaces.nsITreeView.PROGRESS_NONE,

   // Wrapped properties

  get rowCount() {
//    dump('get rowCount\n');
    return this.wrapped_view['rowCount'];
  },
  set rowCount(val) {
//    dump('set rowCount\n');
    this.wrapped_view['rowCount'] = val;
  },

  get selection() {   //called
//    dump('get selection\n');
    return this.wrapped_view['selection'];
  },
  set selection(sel) {
//    dump('set selection\n');
    this.wrapped_view['selection'] = sel;
  },

   // Wrapped methods

  canDrop : function(index, orientation)
  {
//    dump('canDrop\n');
    return this.wrapped_view.canDrop(index, orientation);
  },
  cycleCell : function( row , col )
  {
//    dump('cycleCell\n');
    return this.wrapped_view.cycleCell ( row , col )
  },
  cycleHeader : function( col )
  {
//    dump('cycleHeader\n');
    return this.wrapped_view.cycleHeader ( col )
  },
  drop : function( row , orientation )
  {
//    dump('drop\n');
    return this.wrapped_view.drop ( row , orientation )
  },
/*
  getCellProperties : function( row , col , properties )   //called
  {
//    dump('getCellProperties\n');
    return this.wrapped_view.getCellProperties ( row , col , properties )
  },
*/
/*
  getCellText : function ( row , col )
  {
//    dump('getCellText\n');
    return this.wrapped_view.getCellText ( row , col )
  },
*/
  getCellValue : function ( row , col )
  {
//    dump('getCellValue\n');
    return this.wrapped_view.getCellValue ( row , col )
  },
  getColumnProperties : function ( col , properties )
  {
//    dump('getColumnProperties\n');
    return this.wrapped_view.getColumnProperties ( col , properties )
  },
/*
  getImageSrc : function ( row , col )   //called
  {
//    dump('getImageSrc\n');
    return this.wrapped_view.getImageSrc ( row , col )
  },
*/
  getLevel : function ( index )   //called
  {
//    dump('getLevel\n');
    return this.wrapped_view.getLevel ( index )
  },
  getParentIndex : function ( rowIndex )
  {
//    dump('getParentIndex\n');
    return this.wrapped_view.getParentIndex ( rowIndex )
  },
  getProgressMode : function ( row , col )
  {
//    dump('getProgressMode\n');
    return this.wrapped_view.getProgressMode ( row , col )
  },
  hasNextSibling : function ( rowIndex , afterIndex )
  {
//    dump('hasNextSibling\n');
    return this.wrapped_view.hasNextSibling ( rowIndex , afterIndex )
  },
  isContainer : function ( index )   //called
  {
//    dump('isContainer\n');
    return this.wrapped_view.isContainer ( index )
  },
  isContainerEmpty : function ( index )
  {
//    dump('isContainerEmpty\n');
    return this.wrapped_view.isContainerEmpty ( index )
  },
  isContainerOpen : function ( index )
  {
//    dump('isContainerOpen\n');
    return this.wrapped_view.isContainerOpen ( index )
  },
  isEditable : function ( row , col )
  {
//    dump('isEditable\n');
    return this.wrapped_view.isEditable ( row , col )
  },
  isSeparator : function ( index )
  {
//    dump('isSeparator\n');
    return this.wrapped_view.isSeparator ( index )
  },
  isSorted : function ( ) //called
  {
//    dump('isSorted\n');
    return this.wrapped_view.isSorted ( )
  },
  performAction : function ( action )
  {
//    dump('performAction\n');
    return this.wrapped_view.performAction ( action )
  },
  performActionOnCell : function ( action , row , col )
  {
//    dump('performActionOnCell\n');
    return this.wrapped_view.performActionOnCell ( action , row , col )
  },
  performActionOnRow : function ( action , row )
  {
//    dump('performActionOnRow\n');
    return this.wrapped_view.performActionOnRow ( action , row )
  },
  selectionChanged : function ( )
  {
//    dump('selectionChanged\n');
    return this.wrapped_view.selectionChanged ( )
  },
  setCellText : function ( row , col , value )
  {
    dump('setCellText row='+row+'col='+col.id+'\n');
    return this.wrapped_view.setCellText ( row , col , value )
  },
  setCellValue : function ( row , col , value )
  {
    dump('setCellValue row='+row+'col='+col.id+'value='+value+'\n');
    return this.wrapped_view.setCellValue ( row , col , value )
  },
/*
  setTree : function ( tree ) //called
  {
    dump('setTree\n');
    return this.wrapped_view.setTree ( tree )
  },
*/
  toggleOpenState : function ( index )
  {
    dump('toggleOpenState\n');
    return this.wrapped_view.toggleOpenState ( index )
  }
};


// Call when the window is fully loaded, prevent racing condition
window.addEventListener("load", sio_init, false);
//setTimeout(sio_init, 1000);


/* called in TB V2.0 only! */
var sio_CreateDbObserver = {
  // Components.interfaces.nsIObserver
  observe: function(aMsgFolder, aTopic, aData)
  {
    gDBView.addColumnHandler("sio_inoutCol", sio_columnHandler_inoutCol);
    gDBView.addColumnHandler("sio_inoutaddressCol", sio_columnHandler_inoutaddressCol);
  }
}

function dumpTree() {
  var tree=document.getElementById('threadTree');
//  dump('DOM: '+tree.tagName+'\n');
  var rows=tree.firstChild.nextSibling; //treechildren, nicht xul:treerows!!!
  //rows.firstChild: ex. nicht!
  //rows.childNodes.length=0 !!!
}

function dumpProps(row, col, properties) {
  for (var i=0; i<properties.Count(); i++) {
    var prop;
    prop=properties.GetElementAt(i).QueryInterface(Components.interfaces.nsIAtom);
    dump('prop ('+row+','+col+'): '+prop.toString()+"\n");
  }
}

